/* CSE 130 Midterm 2 -- Practice Version */
/* Inverse Deltas of an Array */

#include <stdio.h>
#include <stdlib.h>

void fillArray (int * data, int size);

void printArray (int * data, int size);

int main(void)
{
  int num;
  int *array;

  printf("How many elements are in the array? ");
  scanf("%d", &num);

  array = calloc(num, sizeof(int));

  fillArray(array, num);

  printf("Starting array:\n");
  printArray(array, num);

  int deltas[num-1];

  for (int index = 0; index < num - 1; index++)
  {
    /* the inverse delta is the difference between the current element and the next one */
    deltas[index] = array[index] - array[index+1];
  }

  int newArray[num];
  newArray[0] = array[0]; /* Keep the original initial value */

  for (int i = 0; i < num-1; i++)
  {
    /* Next array element is the previous one plus the next delta */
    newArray[i+1] = newArray[i] + deltas[i];
  }

  printf("Final array:\n");
  printArray(newArray, num);
  return 0;
}

/* DO NOT MODIFY THE FOLLOWING FUNCTIONS! */
void fillArray (int * data, int size)
{
  for (int i = 0; i < size; i++)
  {
    int val;
    printf("Enter the next array value: ");
    scanf("%d", &val);
    data[i] = val;
  }
}

void printArray (int * data, int size)
{
  printf("[");

  for (int i = 0; i < size; i++)
  {
    printf(" %d", data[i]);
  }

  printf("]\n");
}
